'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

module.exports = {
  get: get
};

function get(doc, pointer) {
  return traverse(doc, parse(pointer));
}

function traverse(doc, tokens) {
  if (!tokens.length) return doc;

  var next = tokens.shift();
  return traverse(doc[next], tokens);
}

function parse(pointer) {
  validatePointer(pointer);
  return normaliseFragment(pointer).split('/').slice(1).map(unescape);
}

function normaliseFragment(pointer) {
  return isURIFragment(pointer) ? decodeURIComponent(pointer).slice(1) : pointer;
}

function isURIFragment(string) {
  return string && string[0] === '#';
}

function unescape(token) {
  return token.replace('~1', '/').replace('~0', '~');
}

var validPointer = /^([#\/]?$|#?\/.*)/;

function validatePointer(pointer) {
  if (!validPointer.test(pointer)) {
    throw new InvalidPointerError(pointer);
  }
}

var InvalidPointerError = function (_Error) {
  _inherits(InvalidPointerError, _Error);

  function InvalidPointerError(pointer) {
    _classCallCheck(this, InvalidPointerError);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(InvalidPointerError).call(this, 'Pointer "' + pointer + '" is invalid'));

    _this.name = 'InvalidPointerError';
    return _this;
  }

  return InvalidPointerError;
}(Error);